%global namedreltag .Final
%global namedversion %{version}%{namedreltag}

Summary:        Various frameworks to build RESTful Web Services and RESTful Java applications
Name:           resteasy
Version:        3.0.26
Release:        4%{?dist}
License:        Apache-2.0
URL:            http://resteasy.jboss.org/
Source0:        https://github.com/resteasy/Resteasy/archive/%{namedversion}/%{name}-%{namedversion}.tar.gz

Patch3001:      0001-RESTEASY-2559-Improper-validation-of-response-header.patch
Patch3002:      0001-Remove-Log4jLogger.patch
Patch3003:      0001-Replace-javax.activation-imports-with-jakarta.activa.patch
Patch3004:      0001-Update-to-new-jakarta-xml-bind-namespace.patch

BuildRequires:  maven-local
BuildRequires:  mvn(commons-io:commons-io)
BuildRequires:  mvn(jakarta.activation:jakarta.activation-api)
BuildRequires:  mvn(jakarta.xml.bind:jakarta.xml.bind-api)
BuildRequires:  mvn(org.apache.httpcomponents:httpclient)
BuildRequires:  mvn(org.apache.maven.plugins:maven-source-plugin)
BuildRequires:  mvn(org.apache.tomcat:tomcat-servlet-api)
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-annotations)
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires:  mvn(com.fasterxml.jackson.jaxrs:jackson-jaxrs-json-provider)
BuildRequires:  mvn(org.jboss:jboss-parent:pom:)
BuildRequires:  mvn(org.jboss.logging:jboss-logging)
BuildRequires:  mvn(org.jboss.logging:jboss-logging-annotations)
BuildRequires:  mvn(org.jboss.logging:jboss-logging-processor)
BuildRequires:  mvn(javax.annotation:javax.annotation-api)
BuildRequires:  mvn(org.jboss.spec.javax.ws.rs:jboss-jaxrs-api_2.0_spec)
BuildRequires:  mvn(org.slf4j:slf4j-api)

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

%description
RESTEasy is a JBoss project that provides various frameworks
to help you build RESTful Web Services and RESTful Java
applications. It is an implementation of the Jakarta RESTful
Web Services, an Eclipse Foundation specification that provides
a Java API for RESTful Web Services over the HTTP protocol.

%package -n     pki-%{name}
Summary:        Framework for RESTful Web services and Java applications
Requires:       pki-%{name}-client = %{version}-%{release}
Requires:       pki-%{name}-core = %{version}-%{release}
Requires:       pki-%{name}-jackson2-provider = %{version}-%{release}
Provides:       %{name} = %{version}-%{release}
Obsoletes:      %{name} < %{version}-%{release}
Conflicts:      %{name} < %{version}-%{release}

%description -n pki-%{name}
RESTEasy is a JBoss project that provides various frameworks
to help you build RESTful Web Services and RESTful Java
applications. It is an implementation of the Jakarta RESTful
Web Services, an Eclipse Foundation specification that provides
a Java API for RESTful Web Services over the HTTP protocol.

%package -n     pki-%{name}-core
Summary:        Core modules for %{name}
Provides:       %{name}-core = %{version}-%{release}
Obsoletes:      resteasy-jaxrs-api < 3.0.7
Obsoletes:      %{name}-core < %{version}-%{release}
Conflicts:      %{name}-core < %{version}-%{release}

%description -n pki-%{name}-core
RESTEasy is a JBoss project that provides various frameworks
to help you build RESTful Web Services and RESTful Java
applications. It is an implementation of the Jakarta RESTful
Web Services, an Eclipse Foundation specification that provides
a Java API for RESTful Web Services over the HTTP protocol.

%package -n     pki-%{name}-jackson2-provider
Summary:        Module jackson2-provider for %{name}
Provides:       %{name}-jackson2-provider = %{version}-%{release}
Obsoletes:      %{name}-jackson2-provider < %{version}-%{release}
Conflicts:      %{name}-jackson2-provider < %{version}-%{release}

%description -n pki-%{name}-jackson2-provider
RESTEasy is a JBoss project that provides various frameworks
to help you build RESTful Web Services and RESTful Java
applications. It is an implementation of the Jakarta RESTful
Web Services, an Eclipse Foundation specification that provides
a Java API for RESTful Web Services over the HTTP protocol.

%package -n     pki-%{name}-client
Summary:        Client for %{name}
Provides:       %{name}-client = %{version}-%{release}
Obsoletes:      %{name}-client < %{version}-%{release}
Conflicts:      %{name}-client < %{version}-%{release}

%description -n pki-%{name}-client
RESTEasy is a JBoss project that provides various frameworks
to help you build RESTful Web Services and RESTful Java
applications. It is an implementation of the Jakarta RESTful
Web Services, an Eclipse Foundation specification that provides
a Java API for RESTful Web Services over the HTTP protocol.

%prep
%autosetup -n Resteasy-%{namedversion} -p1

%pom_disable_module arquillian
%pom_disable_module eagledns
%pom_disable_module jboss-modules
%pom_disable_module profiling-tests
%pom_disable_module resteasy-bom
%pom_disable_module resteasy-cache
%pom_disable_module resteasy-cdi
%pom_disable_module resteasy-dependencies-bom
%pom_disable_module resteasy-guice
%pom_disable_module resteasy-jaxrs-testsuite
%pom_disable_module resteasy-jsapi
%pom_disable_module resteasy-jsapi-testing
%pom_disable_module resteasy-links
%pom_disable_module resteasy-servlet-initializer
%pom_disable_module resteasy-spring
%pom_disable_module resteasy-wadl
%pom_disable_module resteasy-wadl-undertow-connector
%pom_disable_module security
%pom_disable_module server-adapters
%pom_disable_module testsuite
%pom_disable_module tjws

pushd providers
%pom_disable_module fastinfoset
%pom_disable_module jackson
%pom_disable_module jettison
%pom_disable_module json-p-ee7
%pom_disable_module multipart
%pom_disable_module resteasy-atom
%pom_disable_module resteasy-html
%pom_disable_module resteasy-validator-provider-11
%pom_disable_module yaml
%pom_disable_module jaxb
popd

find -name '*.jar' -print -delete

%pom_remove_plugin :maven-clover2-plugin
%pom_remove_plugin :maven-javadoc-plugin

%pom_change_dep javax.activation:activation jakarta.activation:jakarta.activation-api:2.1.1 resteasy-jaxrs
%pom_change_dep javax.activation:activation jakarta.activation:jakarta.activation-api:2.1.1 resteasy-spring

%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api jboss-modules
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api providers/jaxb
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api resteasy-dependencies-bom
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api resteasy-guice
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api resteasy-jaxrs
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api resteasy-links
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api resteasy-spring
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api security/keystone/keystone-core
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api security/resteasy-crypto
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api security/skeleton-key-idm/skeleton-key-core
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api security/skeleton-key-idm/skeleton-key-idp
%pom_change_dep org.jboss.spec.javax.annotation:jboss-annotations-api_1.2_spec javax.annotation:javax.annotation-api server-adapters/resteasy-jdk-http

%pom_remove_dep "org.jboss.resteasy:resteasy-dependencies"
%pom_remove_dep net.jcip:jcip-annotations resteasy-jaxrs
%pom_remove_dep junit:junit resteasy-client
%pom_remove_dep junit:junit providers/resteasy-atom
%pom_remove_dep junit:junit providers/jaxb
%pom_remove_dep junit:junit resteasy-jaxrs
%pom_remove_dep log4j:log4j resteasy-jaxrs

%pom_change_dep org.jboss.spec.javax.servlet: org.apache.tomcat:tomcat-servlet-api resteasy-jaxrs
%pom_change_dep org.jboss.spec.javax.servlet: org.apache.tomcat:tomcat-servlet-api providers/abdera-atom
%pom_change_dep org.jboss.spec.javax.servlet: org.apache.tomcat:tomcat-servlet-api providers/jaxb
%pom_change_dep org.jboss.spec.javax.servlet: org.apache.tomcat:tomcat-servlet-api providers/jackson2

%pom_add_dep jakarta.xml.bind:jakarta.xml.bind-api resteasy-jaxrs

%pom_remove_plugin :maven-clean-plugin

%mvn_package ":resteasy-jaxrs" core
%mvn_package ":providers-pom" core
%mvn_package ":resteasy-jaxrs-all" core
%mvn_package ":resteasy-pom" core
%mvn_package ":resteasy-jackson2-provider" jackson2-provider
%mvn_package ":resteasy-client" client

%pom_add_plugin org.apache.maven.plugins:maven-source-plugin . '
<configuration>
 <skipSource>true</skipSource>
</configuration>'

%build
%mvn_build -f -j

%install
%mvn_install

%files -n pki-%{name}
%license License.html
%doc README.md

%files -n pki-%{name}-core -f .mfiles-core
%license License.html

%files -n pki-%{name}-jackson2-provider -f .mfiles-jackson2-provider
%license License.html

%files -n pki-%{name}-client -f .mfiles-client
%license License.html

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.26-4
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.26-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.26-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 26 2023 Miaojun Dong <zoedong@tencent.com> - 3.0.26-1
- initial build
